#include <bits/stdc++.h>
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)

using namespace std;

typedef long long ll;


int get(vector<string> &A) {
	int n = (int)A.size();
	vector<int> T(n + 1);
	for (int i = 0; i < n; i++) {
		T[i + 1] = T[i] + (i ? (A[i] == A[i - 1]) : 0);
	}	
	for (int len = n; len >= 1; len--) if (n % len == 0) {
		int ok = 1;
		for (int i = 0; i < n; i += len) {
			ok &= (T[i + len] - T[i + 1] == len - 1);
		}
		if (ok) return len;
	}
	assert(0);
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	
	int n, m;
	cin >> n >> m;
	
	vector<string> A(n);
	for (int i = 0; i < n; i++) cin >> A[i];
	
	vector<string> B(m);
	for (int j = 0; j < m; j++) for (int i = 0; i < n; i++) B[j] += A[i][j];
	
	int lena = get(A);
	int lenb = get(B);
	
	cout << n / lena << " " << m / lenb << "\n";
	for (int i = 0; i < n; i += lena) {
		for (int j = 0; j < m; j += lenb) {
			cout << A[i][j];
		}
		cout << "\n";
	}
	return 0;
}