#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;
    vector<string> f(n);
    for (int i = 0; i < n; i++) {
        cin >> f[i];
    }

    vector<int> dn, dm;
    for (int i = 1; i <= n; i++) {
        if (n % i == 0) {
            dn.push_back(i);
        }
    }
    reverse(dn.begin(), dn.end());
    for (int i = 1; i <= m; i++) {
        if (m % i == 0) {
            dm.push_back(i);
        }
    }
    reverse(dm.begin(), dm.end());

    int ba = 1, bb = 1;
    int ans = n * m;

    for (int a : dn) {
        for (int b : dm) {
            if ((n / a) * (m / b) >= ans) {
                continue;
            }

            bool ok = true;
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j++) {
                    if (f[i][j] != f[i / a * a][j / b * b]) {
                        ok = false;
                        break;
                    }
                }
                if (!ok) {
                    break;
                }
            }

            if (ok) {
                int cur = (n / a) * (m / b);
                if (cur < ans) {
                    ans = cur;
                    ba = a;
                    bb = b;
                }
            }
        }
    }

    cout << n / ba << " " << m / bb << endl;
    for (int i = 0; i < n; i += ba) {
        string cur;
        for (int j = 0; j < m; j += bb) {
            cur.push_back(f[i][j]);
        }
        cout << cur << "\n";
    }

    return 0;
}
